#include <windows.h>
#include <semaphore.h>

static sem_t thelock;


BOOL WINAPI
DllMain (HINSTANCE hinstDll, DWORD fdwReason, LPVOID lpvReserved)
{
    int status;
    switch (fdwReason)
	{
	case DLL_PROCESS_ATTACH:
	    printf("DLL_PROCESS_ATTACH\n");
	case DLL_THREAD_DETACH:
	    printf("DLL_THREAD_DETACH\n");
	    sem_wait(&thelock);
	    sem_post(&thelock);
	    printf("DLL_THREAD_DETACHED\n");
	}
}

__declspec(dllexport) int init_library()
{
    int status = sem_init(&thelock,0,1);
    return status;
}
